package org.jxmpp.stringprep;

import java.io.IOException;

public class XmppStringprepException extends IOException {
   private static final long serialVersionUID = -8491853210107124624L;
   private final String causingString;

   public XmppStringprepException(String causingString, Exception exception) {
      super("XmppStringprepException caused by '" + causingString + "': " + exception);
      this.initCause(exception);
      this.causingString = causingString;
   }

   public XmppStringprepException(String causingString, String message) {
      super(message);
      this.causingString = causingString;
   }

   public String getCausingString() {
      return this.causingString;
   }
}
