package org.jivesoftware.smack.packet;

import org.jivesoftware.smack.util.XmlStringBuilder;

public class StartTls extends FullStreamElement {
   public static final String ELEMENT = "starttls";
   public static final String NAMESPACE = "urn:ietf:params:xml:ns:xmpp-tls";
   private final boolean required;

   public StartTls() {
      this(false);
   }

   public StartTls(boolean required) {
      this.required = required;
   }

   public boolean required() {
      return this.required;
   }

   public String getElementName() {
      return "starttls";
   }

   public String getNamespace() {
      return "urn:ietf:params:xml:ns:xmpp-tls";
   }

   public XmlStringBuilder toXML() {
      XmlStringBuilder xml = new XmlStringBuilder(this);
      xml.rightAngleBracket();
      xml.condEmptyElement(this.required, "required");
      xml.closeElement((NamedElement)this);
      return xml;
   }
}
